## ghc6 6.12.1

=== bindisttest/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

.PHONY: default_target

default_target: all

# Ideally we'd just include something to give us variables
# for paths and arguments to tools etc, and those set in mk/build.mk.
TOP=..
include $(TOP)/mk/config.mk

ifeq "$(TEST_PREP)" "YES"
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_PREP_TAR_BZ2)
else
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_TAR_BZ2)
endif

all:
	$(RM) -rf $(BIN_DIST_INST_SUBDIR)
	$(RM) -rf a/b/c/*
	$(RM) HelloWorld HelloWorld.o HelloWorld.hi output
# We use the a/b/c subdirectory as configure looks for install-sh in
# . .. ../.. and we don't want it to find the build system's install-sh.
# --force-local makes tar not think that c:/foo refers to a remote file
	cd a/b/c/ && $(TAR) --force-local -jxf ../../../$(BIN_DIST_TEST_TAR_BZ2)
ifeq "$(Windows)" "YES"
	mv a/b/c/$(BIN_DIST_NAME) $(BIN_DIST_INST_DIR)
else
	cd a/b/c/$(BIN_DIST_NAME) && ./configure --prefix=$(BIN_DIST_INST_DIR)
	cd a/b/c/$(BIN_DIST_NAME) && make install
endif
	$(BIN_DIST_INST_DIR)/bin/runghc HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc --make HelloWorld
	./HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check

clean distclean:
	$(RM) -rf $(BIN_DIST_INST_SUBDIR)
	$(RM) -rf a/b/c/*
	$(RM) HelloWorld HelloWorld.o HelloWorld.hi output

# Ignore a load of other standard targets
install install-docs doc:
	@:

=== distrib/MacOS/Makefile ===
############################################################################
#
#		This is the GHC Makefile for MacOS X-specific targets
#
# Targets: 
#
#	framework-pkg  [MacOS only]
#		Builds /Library/Frameworks/GHC.framework wrapped into a Mac
#		installer package; must be executed in a ./configure'd tree
#		(--prefix doesn't matter as it will be overridden); other
#		./configure arguments are passed through, unless overwritten
#		with XCODE_EXTRA_CONFIGURE_ARGS.  A deployment target can
#		be specified by setting the corresponding ./configure
#		argument or by setting MACOSX_DEPLOYMENT_TARGET.
#
#	framework-binary-dist  [MacOS only]
#		Builds GHC.framework encapsulating a binary distribution
#		(to give a relocatable framework); must be used in a fully
#		built tree
#
############################################################################

include ../../mk/config.mk

ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif

include ../../mk/custom-settings.mk

# The ProjectVersionInt is GHC's idea of an API version and hence determines
# the framework version.
FRAMEWORK_VERSION = $(ProjectVersionInt)

# Xcode requires CURRENT_PROJECT_VERSION to be an int or float.  We use this
# only as the build version (aka CFBundleVersion).
CURRENT_PROJECT_VERSION = $(ProjectVersionInt).$(ProjectPatchLevel)

# The user-visible CFBundleShortVersionString is set to the standard GHC 
# version number.
SHORT_VERSION_STRING = $(ProjectVersion)

# Name of the installer package
PACKAGE_NAME = GHC-$(ProjectVersion)-$(TargetArch_CPP).pkg

# Determine arguments that should be passed to ./configure from within Xcode
#
# By default, we pass whatever was used when the present tree was configured.
# The user can override this by setting XCODE_EXTRA_CONFIGURE_ARGS.  If
# MACOSX_DEPLOYMENT_TARGET is set, the target is added to whatever arguments
# are passed.
export XCODE_EXTRA_CONFIGURE_ARGS
ifeq "$(XCODE_EXTRA_CONFIGURE_ARGS)" ""
XCODE_EXTRA_CONFIGURE_ARGS = $(shell echo $(CONFIGURE_ARGS))
endif
ifneq "$(MACOSX_DEPLOYMENT_TARGET)" ""
XCODE_EXTRA_CONFIGURE_ARGS += --with-macosx-deployment-target=$(MACOSX_DEPLOYMENT_TARGET)
endif

# Determine whether we need to pass a "-target" option to packagemaker
#
# If a deployment target has been set, we use the same target for packagemaker.
ifneq "$(MACOSX_DEPLOYMENT_TARGET)" ""
PACKAGEMAKER_TARGET = -target $(MACOSX_DEPLOYMENT_TARGET)
endif

# Xcode's installation build product location (this is where the GHC.framework
# is assembled)
DSTROOT=/tmp/GHC.dst

# Tools directory for a system volume install
TOOLS_SYSTEM=$(DSTROOT)/Library/Frameworks/GHC.framework/Tools

PACKAGEMAKER=/Developer/usr/bin/packagemaker

# Build and package GHC.framework for /Library/Frameworks
#
# * Be careful to clean out Xcode's build product location first, as Xcode
#   sets permissions such that a second install on top of an existing one
#   fails
# * Make there are no contents component descriptions in the .pmdoc.  These are
#   created by the PackageMaker GUI and have per default the wrong ownership
#   and permissions for all files (as well as prevent correct setting of those
#   for files that are not in the content list).
framework-pkg:
	-chmod -fR u+w $(DSTROOT)
	-$(RM) -rf $(DSTROOT)
	mkdir -p $(TOOLS_SYSTEM)
	cp installer-scripts/Uninstaller $(TOOLS_SYSTEM)
	xcodebuild -target GHC-systemwide clean build\
		   CURRENT_PROJECT_VERSION=$(CURRENT_PROJECT_VERSION)\
	    	   SHORT_VERSION_STRING=$(SHORT_VERSION_STRING)\
	 	   FRAMEWORK_VERSION=$(FRAMEWORK_VERSION)\
		   CURRENT_LIBRARY_VERSION=$(FRAMEWORK_VERSION)\
		   COMMAND_MODE=unix2003
	xcodebuild -target GHC-systemwide install\
		   CURRENT_PROJECT_VERSION=$(CURRENT_PROJECT_VERSION)\
	    	   SHORT_VERSION_STRING=$(SHORT_VERSION_STRING)\
	 	   FRAMEWORK_VERSION=$(FRAMEWORK_VERSION)\
		   CURRENT_LIBRARY_VERSION=$(FRAMEWORK_VERSION)\
		   COMMAND_MODE=unix2003
	-$(RM) -f GHC-system.pmdoc/*-contents.xml
	$(PACKAGEMAKER) -v --doc GHC-system.pmdoc\
			$(PACKAGEMAKER_TARGET) -o $(TOP)/$(PACKAGE_NAME)

# If we don't specify COMMAND_MODE=unix2003 then xcodebuild defaults
# to setting it to legacy, which means that ar builds archives
# without a table of contents. That makes the build fail later on.



# Instead of making 'binary-dist' a Makefile dependency, we let xcodebuild call
# 'make binary-dist'.  This has the advantage that xcode knows the framework
# path into which the distribution should be installed and can instruct 
# binary-dist to put it directly into the right place without copying the whole
# tree yet another time.
#
framework-binary-dist:
	xcodebuild -target GHC-relocatable clean build\
		   CURRENT_PROJECT_VERSION=$(CURRENT_PROJECT_VERSION)\
	    	   SHORT_VERSION_STRING=$(SHORT_VERSION_STRING)\
	 	   FRAMEWORK_VERSION=$(FRAMEWORK_VERSION)\
		   CURRENT_LIBRARY_VERSION=$(FRAMEWORK_VERSION)
	@echo "FIXME: call the packager"; exit 1
	# FIXME: The approach with the binary-dist in the package has the
	# problem that the BOM is wrong and the installer relocation feature
	# isn't sufficient as the layout in the binary-dist and the installed
	# tree is different

=== docs/ext-core/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

ifeq "$(LATEX_DOCS)" "YES"
all: pdf

install-docs:
	-mkdir      $(docdir)/ext-core
	cp core.pdf $(docdir)/ext-core/
else
all:
install-docs:
endif

#	General makefile for Latex stuff

LATEX=latex \\nonstopmode \\input
PDFLATEX=pdflatex
BIBTEX=bibtex

dvi: core.dvi
ps: core.ps core.ps.gz
pdf: core.pdf

core.pdf: core.tex
	$(PDFLATEX) core.tex
	$(BIBTEX) core
	$(PDFLATEX) core.tex
	$(PDFLATEX) core.tex

######## General rules
.SUFFIXES:
.PRECIOUS: %.tex %.ps %.ps.gz %.pdf %.bbl


%.gz: %
	gzip < $< > $@

%.ps: %.dvi
	dvips -f < $< > $@

%.pdf: %.ps
	ps2pdf $< $@

clean:
	$(RM) *.aux *.log

distclean: clean
	$(RM) prims.tex *.dvi *.ps *.pdf *.bbl *.blg *.gz

maintainer-clean: distclean

include $(TOP)/mk/bindist.mk

# dummy targets
boot:
install:
html:
chm:
HxS:

# End of file

=== libraries/Cabal/Makefile ===

VERSION=1.8.0.2

#KIND=devel
KIND=rc
#KIND=latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,
VERSION_VALUE=$(subst .,$(COMMA),$(VERSION))

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -DCABAL_VERSION=$(VERSION_VALUE) -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

XMLLINT=xmllint
XMLLINT_OPTIONS=--nonet --noout --valid

XSLTPROC=xsltproc
XSLTPROC_HTML_OUTDIR=dist/doc/users-guide/
XSLTPROC_HTML_CSS=Cabal.css
XSLTPROC_HTML_PARAMS=\
	--param use.id.as.filename 1 \
	--param toc.section.depth 3 \
	--stringparam base.dir $(XSLTPROC_HTML_OUTDIR) \
	--stringparam html.stylesheet $(XSLTPROC_HTML_CSS)
XSLTPROC_HTML_STYLESHEET=http://docbook.sourceforge.net/release/xsl/current/html/chunk.xsl
XSLTPROC_OPTIONS=--nonet $(XSLTPROC_HTML_PARAMS) $(XSLTPROC_HTML_STYLESHEET)

users-guide: $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/Cabal.xml
	$(XMLLINT) $(XMLLINT_OPTIONS) $<
	$(XSLTPROC) $(XSLTPROC_OPTIONS) $<
	cp doc/$(XSLTPROC_HTML_CSS) $(XSLTPROC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -c Cabal-$(VERSION) -zf $(DISTLOC)/Cabal-$(VERSION).tar.gz
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) www.haskell.org:/home/haskell/cabal/release/cabal-$(VERSION)
	ssh www.haskell.org 'cd /home/haskell/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== debian/changelog ===
ghc6 (6.12.1-13ubuntu1) maverick; urgency=low

  * Backport some fixes from Debian experimental to fix issues in the
    Ubuntu package without having to upgrade to a new release. The
    following changelog entries are copied from the Debian
    changelog. Thanks to Kari Pahula (kaol) for implementing the
    fixes. As soon as 6.12.3 is in unstable, ghc6 can be synced again.
  * Only insert packages in gen_contents_index which are both registered
    and for which the html directory exists.
  * Use ghc-pkg --global in ghc6's trigger to avoid accessing HOME.
    (Closes: #578679) (LP: #596784)
  * Fix directories in haddock manpage.  (Closes: #578321)
  * Downgrade ghc6's dependency on perl to Suggests and have ghc6-doc
    depend on perl.  (Closes: #553332)
  * Standards-Version 3.9.0 (no changes necessary)
  * ghc6 package now provides ghc6-ghci on architectures where it's
    supported (i386 and amd64 only currently).

 -- Iain Lane <laney@ubuntu.com>  Wed, 25 Aug 2010 14:03:34 +0100

ghc6 (6.12.1-13) unstable; urgency=low

  * Remove debian/watcher.sh.  (Closes: #571824)
  * Don't ship /var/lib/ghc-6.12.1/package.conf.d/package.cache with ghc6.
    (Closes: #574417)
  * Patch compiler/rename/RnSource.lhs to make hlist happy.
  * Remove some more generated .hc files in debian/rules clean.
  * Don't ship broken symlink /usr/lib/ghc-6.12.1/package.conf

 -- Kari Pahula <kaol@debian.org>  Sat, 17 Apr 2010 10:35:25 +0300

ghc6 (6.12.1-12) unstable; urgency=low

  * Fix the kfreebsd-* patch.
  * Don't die in ghc6's trigger if ghc-pkg check fails.  (Closes: #570921)
  * Recognise DEB_BUILD_OPTIONS=parallel.

 -- Kari Pahula <kaol@debian.org>  Mon, 22 Feb 2010 15:08:48 +0200

ghc6 (6.12.1-11) unstable; urgency=low

  * Add "unset LC_ALL\nexport LC_CTYPE=en_US" to bin/ghc wrapper on ia64.
  * Actually append GhcWithInterpreter=YES to mk/build.mk on kfreebsd-*,
    don't just echo it to stdout.

 -- Kari Pahula <kaol@debian.org>  Mon, 22 Feb 2010 03:24:02 +0200

ghc6 (6.12.1-10) unstable; urgency=low

  * Use dh_haskell_depends from haskell-devscripts to create provides
    including the packages ABI.
  * Make provided substvar for utf8-string too.
  * Run "ghc-pkg check" in ghc6's trigger also.
  * Added a stub /usr/share/doc/ghc6-doc/index.html that redirects to
    html/index.html.

 -- Kari Pahula <kaol@debian.org>  Fri, 19 Feb 2010 18:08:57 +0200

ghc6 (6.12.1-9) unstable; urgency=low

  * Remove /usr/lib/ghc-$(ProjectVersion)/lib/haddock (ie. the internal
    haddock binary that ghc6 used at build time) from the ghc6 package.
  * Install haddock's files from /usr/share/haddock-$VERSION in ghc6
    package, not ghc6-doc.

 -- Kari Pahula <kaol@debian.org>  Sat, 13 Feb 2010 02:49:11 +0200

ghc6 (6.12.1-8) unstable; urgency=low

  * Use tabs instead of 8 spaces in debian/rules for ia64 specific flags.

 -- Kari Pahula <kaol@debian.org>  Wed, 10 Feb 2010 13:19:32 +0200

ghc6 (6.12.1-7) unstable; urgency=low

  * Include patches to haddock to ghc6's own patches and don't apply them
    in debian/rules.
  * Update the patch for alpha.
  * ghc6-doc depends on ghc6 (>= ${binary:Version}), not haddock.
  * Upload to unstable.

 -- Kari Pahula <kaol@debian.org>  Tue, 09 Feb 2010 23:45:14 +0200

ghc6 (6.12.1-6) experimental; urgency=low

  * Use some more compiler flags to make ghc6 build on ia64 for real.
  * Patch TcForeign.lhs and EventLog.c to make ghc6 build on alpha.

 -- Kari Pahula <kaol@debian.org>  Mon, 08 Feb 2010 13:58:59 +0200

ghc6 (6.12.1-5) experimental; urgency=low

  * Included haddock with the ghc6 package.  Provides, conflicts and
    replaces haddock.  Copied over haddock.1 from the haddock package.
  * Build with UseLibFFIForAdjustors=YES on alpha.
  * Set ghc6 depend on libc6-dev. (Closes: #567809)
  * Standards-Version 3.8.4, no changes necessary.
  * Patch up the sources some more for kfreebsd. (Closes: #567298)

 -- Kari Pahula <kaol@debian.org>  Fri, 05 Feb 2010 12:05:15 +0200

ghc6 (6.12.1-4) experimental; urgency=low

  * Patched utils/haddock/src/Haddock/Interface/Create.hs to use
    lookupGlobalName instead of lookupName when GHCI is
    unavailable. (Closes: #566331)

 -- Kari Pahula <kaol@debian.org>  Thu, 28 Jan 2010 11:46:55 +0200

ghc6 (6.12.1-3) experimental; urgency=low

  * Updated ghc-pkg's man page.
  * Added a trigger to run ghc-pkg recache when files are added to
    /var/lib/ghc-6.12.1/package.conf.d/.
  * Patch rts/posix/OSThreads.c to define _GNU_SOURCE on kfreebsd
    too. (Closes: #565818)
  * Patch utils/haddock/src/Haddock/Interface/AttachInstances.hs to use
    Nothing as mb_info in attachInstances when GHCI is
    unavailable. (Closes: #566331)
  * Breaks cabal-install (<< 0.8.0).

 -- Kari Pahula <kaol@debian.org>  Wed, 27 Jan 2010 23:37:32 +0200

ghc6 (6.12.1-2) experimental; urgency=low

  * Added missing build dependency: libncurses5-dev.
  * Use the included haddock to build documentation and drop the
    build-depends-indep on haddock.

 -- Kari Pahula <kaol@debian.org>  Wed, 13 Jan 2010 10:02:15 +0200

ghc6 (6.12.1-1) experimental; urgency=low

  * New upstream release (Closes: #539789)
    * System.Posix.Semaphore fixed. (Closes: #544127)
  * Switch to dpkg-source 3.0 (quilt) format
  * Standards-Version 3.8.3 (no changes necessary).
  * Added a dependency on libbsd-dev (Closes: #549403)
  * Patched compiler/utils/Panic.lhs to add a message to internal GHC
    error messages, suggesting removing .hi files and pointing to
    README.Debian. (Closes: #532443)
  * Don't alter Binary.hs and just let Ints to be stored in architecture
    native format.
  * Don't set XMLDocWays in build.mk since it's not used anymore.
  * Remove lpia arch from debian/rules.
  * Split debian/rules binary to binary-arch and binary-indep. (Closes: #543972)
  * Set SRC_HC_OPTS += -lffi in build.mk and update the patch
    system-libffi to use Debian's packaged libffi.
  * Update the patch to make the build system use /usr/bin/haddock and not
    build its own.



=== debian/control ===
Source: ghc6
Section: haskell
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kari Pahula <kaol@debian.org>
Standards-Version: 3.9.0
Build-Depends: debhelper (>= 7), libgmp3-dev, devscripts, ghc6, grep-dctrl, autotools-dev, gcc (>= 4:4.2), procps | hurd, libffi-dev, autoconf, pkg-config, xsltproc, docbook-xsl, docbook-xml, binutils (>= 2.19.51.20090508) [arm armel], libncurses5-dev
Homepage: http://haskell.org/ghc/

Package: ghc6
Architecture: any
Depends: gcc (>= 4:4.2), libgmp3-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ghc, haddock, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: haddock, ghc6-doc (= 6.12.1-8)
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc6-doc (<= 6.12.1-8)
Suggests: perl, ghc6-prof, ghc6-doc, haskell-doc
Description: GHC - the Glasgow Haskell Compilation system
 Version 6 of the Glorious Glasgow Haskell Compilation system (GHC).  GHC is
 a compiler for Haskell98.
 .
 Haskell is "the" standard lazy functional programming language. Haskell98
 is the current version of the language. The language definition and
 additional documentation can be found in the `haskell-doc' package.
 Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc6-prof
Architecture: any
Provides: ghc-prof, ${provided-profs}, ${haskell:Provides}
Depends: ghc6 (= ${binary:Version}), ${misc:Depends}
Description: Profiling libraries for the Glasgow Haskell Compilation system
 Version 6 of the Glorious Glasgow Haskell Compilation system (GHC).  GHC is
 a compiler for Haskell98.
 .
 Haskell is "the" standard lazy functional programming language. Haskell98
 is the current version of the language. The language definition and
 additional documentation can be found in the `haskell-doc' package.
 Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc6-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Depends: ghc6 (>= ${binary:Version}), ${misc:Depends}
Description: Documentation for the Glasgow Haskell Compilation system
 Version 6 of the Glorious Glasgow Haskell Compilation system (GHC).  GHC is
 a compiler for Haskell98.
 .
 Haskell is "the" standard lazy functional programming language. Haskell98
 is the current version of the language. The language definition and
 additional documentation can be found in the `haskell-doc' package.
 Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell awk -F\' "/^PACKAGE_VERSION='[0-9.]+'\$$/ { print \$$2 }" configure)

GHC=$(firstword $(shell bash -c "type -p ghc6 ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir

	touch configure

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc))
	echo "GhcUnregisterised=NO" >> mk/build.mk
else
	echo "GhcUnregisterised=YES" >> mk/build.mk
endif
ifeq (powerpc,$(DEB_HOST_ARCH)) # See #365497
	echo "GhcWithInterpreter=NO" >> mk/build.mk
endif
ifeq (ia64,$(DEB_HOST_ARCH)) # Tested and seen to be necessary with 6.12.1
	echo "SRC_CC_OPTS += -Wl,--relax" >> mk/build.mk
	echo "SRC_HC_OPTS += -optl-Wl,--relax -optl-Wl,-G0" >> mk/build.mk
	echo "SRC_HC_OPTS += -optc-G0" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
	echo "GhcWithInterpreter=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel alpha))
	echo "UseLibFFIForAdjustors=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc6-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	cp -r utils/haddock debian
	sed -i s/@PROJECTVERSION@/$(ProjectVersion)/ debian/haddock/src/Main.hs
	cd debian/haddock; ../../inplace/bin/ghc-stage2 --make Setup.lhs; ./Setup configure --prefix=/usr --with-compiler=../../inplace/bin/ghc-stage2 --package-db=../../inplace/lib/package.conf.d/; ./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs /var/lib/ghc-$(ProjectVersion)/package.conf.d

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc6-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc6 binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc6
	echo "ghc6: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc6
	echo "ghc6-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc6-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc-$(ProjectVersion)
	mv debian/tmp/usr/lib/ghc-$(ProjectVersion)/package.conf.d \
	   debian/tmp/var/lib/ghc-$(ProjectVersion)/
	rm debian/tmp/var/lib/ghc-$(ProjectVersion)/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64))
	echo 'ghci=ghc6-ghci' >> debian/ghc6.substvars
endif
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-$(ProjectVersion)/haddock/,' debian/tmp/var/lib/ghc-$(ProjectVersion)/package.conf.d/*.conf

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc-$(ProjectVersion) ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	rm -f debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin/haddock debian/tmp/usr/lib/ghc-$(ProjectVersion)/lib/haddock
	cd debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin && \
	    for f in *-$(ProjectVersion); \
	    do ln -s /usr/lib/ghc-$(ProjectVersion)/bin/$$f \
	             ../../../bin/; \
	    done
	cd debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc-$(ProjectVersion)/bin/$$f \
	             ../../../bin/$${f}6; \
	    done
	rm -f debian/tmp/usr/bin/*-$(ProjectVersion)6
	rm -f debian/tmp/usr/bin/runhaskell6
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc-$(ProjectVersion)/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock; ./Setup copy --dest=../tmp

	ProjectVersion=$(ProjectVersion) $(MAKE) -f debian/scripts.mk all

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc6-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc6-doc/
	chmod +x debian/tmp/usr/lib/ghc6-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-$(ProjectVersion)/haddock/
	for f in `find debian/tmp/usr/share/doc/ghc6-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
